﻿using Syncfusion.EJ.Export;
using Syncfusion.JavaScript.Models;
using Syncfusion.XlsIO;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Reflection;
using System.ServiceModel;
using System.ServiceModel.Web;
using System.Text;
using System.Web;
using System.Web.Http;
using System.Web.Script.Serialization;
using System.Security.Cryptography;

namespace SpreadsheetService
{
    [ServiceContract(Namespace = "")]
    [XmlSerializerFormat]
    public class JSXLExportController : ApiController
    {
        // GET api/<controller>
        [System.Web.Http.ActionName("ExportToExcel")]
        [AcceptVerbs("POST")]
        public void ExportToExcel()
        {
            string sheetModel = HttpContext.Current.Request.Params["sheetModel"], sheetData = HttpContext.Current.Request.Params["sheetData"], password = HttpContext.Current.Request.Params["password"];
            if (!string.IsNullOrEmpty(password))
                Spreadsheet.Save(sheetModel, sheetData, "sample", ExportFormat.XLSX, ExcelVersion.Excel2013, password);
            else
                Spreadsheet.Save(sheetModel, sheetData, "sample", ExportFormat.XLSX, ExcelVersion.Excel2013);
        }

        [System.Web.Http.ActionName("ExportToCsv")]
        [AcceptVerbs("Post")]
        public void ExportToCsv()
        {
            string sheetModel = HttpContext.Current.Request.Params["sheetModel"], sheetData = HttpContext.Current.Request.Params["sheetData"];
            Spreadsheet.Save(sheetModel, sheetData, "sample", ExportFormat.CSV);
        }

        [OperationContract]
        [WebGet(BodyStyle = WebMessageBodyStyle.Bare)]
        [System.Web.Http.ActionName("Import")]
        [AcceptVerbs("Post")]
        public HttpResponseMessage Import()
        {
            var files = HttpContext.Current.Request.Files;
            ImportRequest importRequest = new ImportRequest();
            if (files.Count > 0 && files[0].ContentType.IndexOf("image") > -1)
                importRequest.File = new HttpPostedFileWrapper(files[0]);
            else if (files.Count == 0)
            {
                importRequest.Url = HttpContext.Current.Request.Form["url"];
                importRequest.Password = HttpContext.Current.Request.Form["password"];
            }
            else
            {
                var obj = files[0];
                importRequest.FileStream = obj.InputStream;
                importRequest.FileType = obj.FileName.Split('.')[obj.FileName.Split('.').Length - 1];
                importRequest.Password = HttpContext.Current.Request.Form["password"];
                importRequest.File = null;
            }
            string str = Spreadsheet.Open(importRequest);
            return new HttpResponseMessage() { Content = new StringContent(str, Encoding.UTF8, "text/plain") };
        }

    }
}
